"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const hljs_1 = require("./hljs");
const isWorker = ('undefined' !== typeof WorkerGlobalScope) && ("function" === typeof importScripts);
if (isWorker) {
    onmessage = e => {
        const msg = e.data;
        if (!Array.isArray(msg))
            return;
        if (msg[0] !== 1 /* CompactMessageType.RequestComplete */)
            return;
        const [, id, method, params] = msg;
        try {
            if (method !== 'highlight')
                return;
            if (typeof params !== 'object')
                return;
            const { code, lang } = params;
            if (typeof code !== 'string')
                return;
            if (typeof lang !== 'string' && lang !== undefined)
                return;
            const res = (0, hljs_1.highlight)(code, lang);
            const response = [5 /* CompactMessageType.ResponseComplete */, id, res];
            postMessage(response);
        }
        catch (error) {
            const response = [6 /* CompactMessageType.ResponseError */, id, error];
            postMessage(response);
        }
    };
    const ready = [8 /* CompactMessageType.Notification */, 'ready'];
    postMessage(ready);
}
//# sourceMappingURL=worker.js.map